/*
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import model.EntityModelTransport;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import invalidPackageName.JSON;

/**
 * PagedModelEntityModelTransportEmbedded
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2022-07-13T12:36:39.341977+01:00[Europe/London]")
public class PagedModelEntityModelTransportEmbedded {
  public static final String SERIALIZED_NAME_TRANSPORTS = "transports";
  @SerializedName(SERIALIZED_NAME_TRANSPORTS)
  private List<EntityModelTransport> transports = null;

  public PagedModelEntityModelTransportEmbedded() { 
  }

  public PagedModelEntityModelTransportEmbedded transports(List<EntityModelTransport> transports) {
    
    this.transports = transports;
    return this;
  }

  public PagedModelEntityModelTransportEmbedded addTransportsItem(EntityModelTransport transportsItem) {
    if (this.transports == null) {
      this.transports = new ArrayList<>();
    }
    this.transports.add(transportsItem);
    return this;
  }

   /**
   * Get transports
   * @return transports
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<EntityModelTransport> getTransports() {
    return transports;
  }


  public void setTransports(List<EntityModelTransport> transports) {
    this.transports = transports;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PagedModelEntityModelTransportEmbedded pagedModelEntityModelTransportEmbedded = (PagedModelEntityModelTransportEmbedded) o;
    return Objects.equals(this.transports, pagedModelEntityModelTransportEmbedded.transports);
  }

  @Override
  public int hashCode() {
    return Objects.hash(transports);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PagedModelEntityModelTransportEmbedded {\n");
    sb.append("    transports: ").append(toIndentedString(transports)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("transports");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PagedModelEntityModelTransportEmbedded
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (PagedModelEntityModelTransportEmbedded.openapiRequiredFields.isEmpty()) {
          return;
        } else { // has required fields
          throw new IllegalArgumentException(String.format("The required field(s) %s in PagedModelEntityModelTransportEmbedded is not found in the empty JSON string", PagedModelEntityModelTransportEmbedded.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PagedModelEntityModelTransportEmbedded.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PagedModelEntityModelTransportEmbedded` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      JsonArray jsonArraytransports = jsonObj.getAsJsonArray("transports");
      if (jsonArraytransports != null) {
        // ensure the json data is an array
        if (!jsonObj.get("transports").isJsonArray()) {
          throw new IllegalArgumentException(String.format("Expected the field `transports` to be an array in the JSON string but got `%s`", jsonObj.get("transports").toString()));
        }

        // validate the optional field `transports` (array)
        for (int i = 0; i < jsonArraytransports.size(); i++) {
          EntityModelTransport.validateJsonObject(jsonArraytransports.get(i).getAsJsonObject());
        };
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PagedModelEntityModelTransportEmbedded.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PagedModelEntityModelTransportEmbedded' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PagedModelEntityModelTransportEmbedded> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PagedModelEntityModelTransportEmbedded.class));

       return (TypeAdapter<T>) new TypeAdapter<PagedModelEntityModelTransportEmbedded>() {
           @Override
           public void write(JsonWriter out, PagedModelEntityModelTransportEmbedded value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PagedModelEntityModelTransportEmbedded read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PagedModelEntityModelTransportEmbedded given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PagedModelEntityModelTransportEmbedded
  * @throws IOException if the JSON string is invalid with respect to PagedModelEntityModelTransportEmbedded
  */
  public static PagedModelEntityModelTransportEmbedded fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PagedModelEntityModelTransportEmbedded.class);
  }

 /**
  * Convert an instance of PagedModelEntityModelTransportEmbedded to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

